/*
**    FILE    : prototyp.h 
**    PURPOSE : function prototypes for type checking
**    AUTHOR  : Bart De Canne, Belgium (bdc@barco.be)
**    COMPILER: BC++ 3.1 compiler
**    DEPENDENCIES:
**    DATE    : 01-09-1994
**    VERSION : 1.0
*/

/* galois.c */

#ifndef _GALOIS
#define EXT_GALOIS extern
#else
#define EXT_GALOIS
#endif

EXT_GALOIS pPOLYNOM  FreePolynom          (pPOLYNOM                        );
EXT_GALOIS pPOLYARR  FreePolyArr          (pPOLYARR                        );
EXT_GALOIS pGALOIS   FreeGalois           (pGALOIS                         );
EXT_GALOIS pOPTABLE  FreeOpTable          (pOPTABLE                        );
EXT_GALOIS pOPTABLE  AllocOpTable         (pOPTABLE,int,int                );
EXT_GALOIS pOPTABLE  ConstructOpTable     (pOPTABLE,pGALOIS,pOPTABLE       );
EXT_GALOIS pGALOIS   AllocGalois          (pGALOIS,int,int                 );
EXT_GALOIS pPOLYNOM  AllocPolynom         (pPOLYNOM,int,int                );
EXT_GALOIS pPOLYARR  AllocPolyArr         (pPOLYARR,int                    );
EXT_GALOIS int       i_mult               (int,int,pGALOIS,pOPTABLE        );
EXT_GALOIS int       i_add                (int,int,pGALOIS,pOPTABLE        );
EXT_GALOIS int       i_pow                (int,int,pGALOIS,pOPTABLE        );
EXT_GALOIS int       i_add_inv            (int,pGALOIS,pOPTABLE            );
EXT_GALOIS int       i_mult_inv           (int,pGALOIS,pOPTABLE            );
EXT_GALOIS void      ToZero               (pPOLYNOM                        );
EXT_GALOIS pPOLYNOM  MultPoly             (pPOLYNOM,pPOLYNOM,pPOLYNOM,
                                           pOPTABLE,byte                   );
EXT_GALOIS bool      DivPoly              (pPOLYNOM,pPOLYNOM,pPOLYNOM,
                                           pPOLYNOM,pOPTABLE               );
EXT_GALOIS int       f                    (pPOLYNOM,pGALOIS,pOPTABLE,int   );
EXT_GALOIS void      WriteGFToDisk        (char *                          );
EXT_GALOIS void      ReadGFHeaderFromDisk (char *,int *,int *,int *,int *  );
EXT_GALOIS void      ReadGFFromDisk       (pGALOIS,pOPTABLE,pGALOIS,
                                           pOPTABLE,char *                 );
EXT_GALOIS void      PrintPoly            (pPOLYNOM                        );
EXT_GALOIS bool      ComparePoly          (pPOLYNOM,pPOLYNOM               );
EXT_GALOIS pPOLYNOM  CopyPoly             (pPOLYNOM,pPOLYNOM               );
EXT_GALOIS void      AskFileName          (char *,char *                   );
EXT_GALOIS bool      IsPrime              (int                             );

/* stream.c */

#ifndef _STREAM
#define EXT_STREAM extern
#else
#define EXT_STREAM
#endif

EXT_STREAM void      OpenInputStream      (char *                          );
EXT_STREAM void      CloseInputStream     (void                            );
EXT_STREAM void      OpenOutputStream     (char *                          );
EXT_STREAM void      CloseOutputStream    (void                            );
EXT_STREAM void      ResetBuffers         (void                            );
EXT_STREAM bool      EOFReached           (void                            );    
EXT_STREAM void      PutBits              (uint,uint                       );
EXT_STREAM uint      GetBits              (uint                            );

/* generate.c */

#ifndef _GENERATE
#define EXT_GENERATE extern
#else
#define EXT_GENERATE
#endif

EXT_GENERATE void    FindPrimitivePolynomial (void                         );
EXT_GENERATE void    FindMinimalPolynomials  (void                         );
EXT_GENERATE void    GenerateBCH             (void                         );

/* encode.c */

#ifndef _ENCODE
#define EXT_ENCODE extern
#else
#define EXT_ENCODE
#endif

EXT_ENCODE void      EncodeData           (void                            );
EXT_ENCODE int       GetElementIndex      (uint                            );

/* decode.c */

#ifndef _DECODE
#define EXT_DECODE extern
#else
#define EXT_DECODE
#endif

EXT_DECODE void      DecodeData           (void                            );
EXT_DECODE void      PrintDecodeStatistics(void                            );

/* mainprog.c */

#ifndef _MAINPROG
#define EXT_MAINPROG extern
#else
#define EXT_MAINPROG
#endif


/* 
** End of prototyp.h
*/
